/* Problem URL: https://codeforces.com/contest/2151/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    const ll mod = 998244353;
    vl fact(2e5 + 1);
    vl inv(2e5 + 1);

    fact[0] = 1;
    fact[1] = 1;

    nrep(i, 2, 2e5 + 1) {
        fact[i] = (fact[i - 1] * i) % mod;
    }

    auto fpow = [&](ll a, ll p) {
        ll ans = 1;
        rep(i, 30) {
            if ((p >> i) & 1) {
                ans *= a;
                ans %= mod;
            }

            a *= a;
            a %= mod;
        }

        return ans;
    };

    auto comb = [&](ll n, ll k) {
        return (fact[n] * fpow((fact[k] * fact[n - k]) % mod, mod - 2)) % mod;
    };

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vi count(n);
        cin >> count;

        vi lim(n);
        rep(i, n >> 1) {
            lim[i] = 2;
        }

        if (n & 1) {
            lim[n >> 1] = 1;
        }

        auto getans = [&]() {
            if (accumulate(all(count), 0LL) != n) {
                return 0LL;
            }

            ll ans = 1;

            int total = 0;
            for (int i = n - 1; i >= 0; i--) {
                int c = lim[i];
                total += c;

                if (total < count[i]) {
                    return 0LL;
                }

                ans *= comb(total, count[i]);
                ans %= mod;
                total -= count[i];
            }

            return ans;
        };

        cout << getans() << '\n';
    }
}
